/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package com.fabianfdz.UI;

import com.fabianfdz.BusinessLogic.BusinessLogic;
import java.io.IOException;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.swing.JOptionPane;

/**
 *
 * @author fabianfdz
 */
public class MainWindow extends javax.swing.JFrame {

    /**
     * Creates new form MainWindow
     */
    public MainWindow() {
        initComponents();

        if (BusinessLogic.medicosLen() > 0) {
            this.btnGetData.setVisible(false);
        }
    }

    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        btnAgregarPac = new javax.swing.JButton();
        btnPacInfecPorProv = new javax.swing.JButton();
        btnPacInfecPercent = new javax.swing.JButton();
        btnAgregarRes = new javax.swing.JButton();
        btnAgregarMed = new javax.swing.JButton();
        jLabel1 = new javax.swing.JLabel();
        lblReportes = new javax.swing.JLabel();
        btnGetData = new javax.swing.JButton();

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);

        btnAgregarPac.setText("Agregar Paciente");
        btnAgregarPac.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnAgregarPacActionPerformed(evt);
            }
        });

        btnPacInfecPorProv.setText("Pacientes Infectados (Provincia)");
        btnPacInfecPorProv.setToolTipText("");
        btnPacInfecPorProv.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnPacInfecPorProvActionPerformed(evt);
            }
        });

        btnPacInfecPercent.setText("Pacientes Infectados (%)");
        btnPacInfecPercent.setToolTipText("");
        btnPacInfecPercent.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnPacInfecPercentActionPerformed(evt);
            }
        });

        btnAgregarRes.setText("Agregar Resultados de Examen");
        btnAgregarRes.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnAgregarResActionPerformed(evt);
            }
        });

        btnAgregarMed.setText("Agregar Médico");
        btnAgregarMed.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnAgregarMedActionPerformed(evt);
            }
        });

        jLabel1.setFont(new java.awt.Font("Dialog", 1, 18)); // NOI18N
        jLabel1.setText("Hospital La Esperanza ");

        lblReportes.setText("REPORTES");

        btnGetData.setText("Cargar datos");
        btnGetData.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnGetDataActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                        .addComponent(btnPacInfecPorProv, javax.swing.GroupLayout.PREFERRED_SIZE, 229, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addGroup(layout.createSequentialGroup()
                                .addGap(100, 100, 100)
                                .addComponent(jLabel1))
                            .addGroup(layout.createSequentialGroup()
                                .addGap(90, 90, 90)
                                .addComponent(btnAgregarMed, javax.swing.GroupLayout.PREFERRED_SIZE, 229, javax.swing.GroupLayout.PREFERRED_SIZE))
                            .addGroup(layout.createSequentialGroup()
                                .addGap(90, 90, 90)
                                .addComponent(btnAgregarPac, javax.swing.GroupLayout.PREFERRED_SIZE, 229, javax.swing.GroupLayout.PREFERRED_SIZE))
                            .addGroup(layout.createSequentialGroup()
                                .addGap(90, 90, 90)
                                .addComponent(btnAgregarRes, javax.swing.GroupLayout.PREFERRED_SIZE, 229, javax.swing.GroupLayout.PREFERRED_SIZE))
                            .addGroup(layout.createSequentialGroup()
                                .addGap(170, 170, 170)
                                .addComponent(lblReportes))
                            .addGroup(layout.createSequentialGroup()
                                .addGap(90, 90, 90)
                                .addComponent(btnPacInfecPercent, javax.swing.GroupLayout.PREFERRED_SIZE, 229, javax.swing.GroupLayout.PREFERRED_SIZE))))
                    .addGroup(layout.createSequentialGroup()
                        .addContainerGap()
                        .addComponent(btnGetData)))
                .addContainerGap(81, Short.MAX_VALUE))
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addGap(20, 20, 20)
                .addComponent(jLabel1)
                .addGap(18, 18, 18)
                .addComponent(btnAgregarMed)
                .addGap(15, 15, 15)
                .addComponent(btnAgregarPac)
                .addGap(15, 15, 15)
                .addComponent(btnAgregarRes)
                .addGap(35, 35, 35)
                .addComponent(lblReportes)
                .addGap(5, 5, 5)
                .addComponent(btnPacInfecPorProv)
                .addGap(15, 15, 15)
                .addComponent(btnPacInfecPercent)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 46, Short.MAX_VALUE)
                .addComponent(btnGetData)
                .addContainerGap())
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void btnAgregarPacActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnAgregarPacActionPerformed
        String labels[] = BusinessLogic.getMedicos();
        if (labels.length == 0) {
            JOptionPane.showMessageDialog(null, "Se necesita al menos un médico en el sistema para ingresar un paciente.");
        } else {
            try {
                new AgregarPersona(false).setVisible(true);
            } catch (IOException ex) {
                Logger.getLogger(MainWindow.class.getName()).log(Level.SEVERE, null, ex);
            }
            this.dispose();
        }
    }//GEN-LAST:event_btnAgregarPacActionPerformed

    private void btnAgregarResActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnAgregarResActionPerformed
        String labels[] = BusinessLogic.getMedicos();
        if (labels.length == 0) {
            JOptionPane.showMessageDialog(null, "Se necesita al menos un paciente en el sistema para ingresar un resultado.");
        } else {
            new AgregarResultados().setVisible(true);
            this.dispose();
        }
    }//GEN-LAST:event_btnAgregarResActionPerformed

    private void btnAgregarMedActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnAgregarMedActionPerformed
        try {
            new AgregarPersona(true).setVisible(true);
        } catch (IOException ex) {
            Logger.getLogger(MainWindow.class.getName()).log(Level.SEVERE, null, ex);
        }
        this.dispose();
    }//GEN-LAST:event_btnAgregarMedActionPerformed

    private void btnGetDataActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnGetDataActionPerformed
        try {
            BusinessLogic.getMedicosDB();
            BusinessLogic.getPacientesDB();
        } catch (IOException ex) {
            Logger.getLogger(MainWindow.class.getName()).log(Level.SEVERE, null, ex);
        }

        this.btnGetData.setVisible(false);

        JOptionPane.showMessageDialog(null, "¡Pacientes y médicos cargados con éxito!");
    }//GEN-LAST:event_btnGetDataActionPerformed

    private void btnPacInfecPorProvActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnPacInfecPorProvActionPerformed
        new ReportPacientesInfectados().setVisible(true);
        this.dispose();
    }//GEN-LAST:event_btnPacInfecPorProvActionPerformed

    private void btnPacInfecPercentActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnPacInfecPercentActionPerformed
        new ReportPacientesPorcentaje().setVisible(true);
        this.dispose();
    }//GEN-LAST:event_btnPacInfecPercentActionPerformed

    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
        /* Set the Nimbus look and feel */
        //<editor-fold defaultstate="collapsed" desc=" Look and feel setting code (optional) ">
        /* If Nimbus (introduced in Java SE 6) is not available, stay with the default look and feel.
         * For details see http://download.oracle.com/javase/tutorial/uiswing/lookandfeel/plaf.html 
         */
        try {
            for (javax.swing.UIManager.LookAndFeelInfo info : javax.swing.UIManager.getInstalledLookAndFeels()) {
                if ("Nimbus".equals(info.getName())) {
                    javax.swing.UIManager.setLookAndFeel(info.getClassName());
                    break;
                }
            }
        } catch (ClassNotFoundException ex) {
            java.util.logging.Logger.getLogger(MainWindow.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (InstantiationException ex) {
            java.util.logging.Logger.getLogger(MainWindow.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (IllegalAccessException ex) {
            java.util.logging.Logger.getLogger(MainWindow.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (javax.swing.UnsupportedLookAndFeelException ex) {
            java.util.logging.Logger.getLogger(MainWindow.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        }
        //</editor-fold>

        /* Create and display the form */
        java.awt.EventQueue.invokeLater(new Runnable() {
            public void run() {
                new MainWindow().setVisible(true);
            }
        });
    }

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton btnAgregarMed;
    private javax.swing.JButton btnAgregarPac;
    private javax.swing.JButton btnAgregarRes;
    private javax.swing.JButton btnGetData;
    private javax.swing.JButton btnPacInfecPercent;
    private javax.swing.JButton btnPacInfecPorProv;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel lblReportes;
    // End of variables declaration//GEN-END:variables
}
